



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>oracle 12c中的隐含列</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">oracle 12c中的隐含列</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-09 23:07:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div><ins><br /><ins><ins></p>
<div>&nbsp;</div>
<p></ins></ins></ins>&nbsp;</div>
<h2>Invisible Columns</h2>
<p>使用select * from ，desc 等看不到该列，</p>
<blockquote><div>
<pre class="prettyprint linenums">DROP TABLE tab1 PURGE;

CREATE TABLE tab1 (<br />
  id          NUMBER,<br />
  description VARCHAR2(50) INVISIBLE<br />
);

DESC tab1;<br />
 Name                                      Null?    Type<br />
 ----------------------------------------- -------- ----------------------------<br />
 ID                                                 NUMBER

SQL&gt;

INSERT INTO tab1 VALUES (1);<br />
COMMIT;

SELECT * FROM tab1;

        ID<br />
----------<br />
         1

SQL&gt;</pre>
</div></blockquote>
<p>在明确的指定它的名字进行查询的时候仍然是可用的</p>
<blockquote><div>
<pre class="prettyprint linenums">INSERT INTO tab1 (id, description) VALUES (2, 'TWO');<br />
COMMIT;

SELECT id, description<br />
FROM   tab1;

        ID DESCRIPTION<br />
---------- --------------------------------------------------<br />
         1<br />
         2 TWO

SQL&gt;</pre>
</div></blockquote>
<p>下面关于隐含列的几项内容</p>
<ul><li>虚拟列可以设成invisible</li>
<li>一个表可以对隐含列就行分区，</li>
<li>外部表，表簇，临时表中不能包含隐含列</li>
<li>用户自定义的类型不能包含隐含属性</li>
<li>You can not make system generated hidden columns visible.</li></ul>
<h2>Invisible Columns and Column Ordering</h2>
<p>隐含列不分配列的顺序（colum_id），如果一个可见的列设为不可见，那么这个列将放到最后一列</p>
<blockquote><div>
<pre class="prettyprint linenums">DROP TABLE tab1 PURGE;

CREATE TABLE tab1 (<br />
  a NUMBER,<br />
  b NUMBER,<br />
  c NUMBER INVISIBLE<br />
);

COLUMN column_name FORMAT A15

SELECT column_id,<br />
       column_name,<br />
       hidden_column<br />
FROM   user_tab_cols<br />
WHERE  table_name = 'TAB1'<br />
ORDER BY column_id;

 COLUMN_ID COLUMN_NAME     HID<br />
---------- --------------- ---<br />
         1 A               NO<br />
         2 B               NO<br />
           C               YES

SQL&gt; 

ALTER TABLE tab1 MODIFY b INVISIBLE;<br />
ALTER TABLE tab1 MODIFY c VISIBLE;

SELECT column_id,<br />
       column_name,<br />
       hidden_column<br />
FROM   user_tab_cols<br />
WHERE  table_name = 'TAB1'<br />
ORDER BY column_id;

 COLUMN_ID COLUMN_NAME     HID<br />
---------- --------------- ---<br />
         1 A               NO<br />
         2 C               NO<br />
           B               YES

SQL&gt;

ALTER TABLE tab1 MODIFY b VISIBLE;

SELECT column_id,<br />
       column_name,<br />
       hidden_column<br />
FROM   user_tab_cols<br />
WHERE  table_name = 'TAB1'<br />
ORDER BY column_id;

 COLUMN_ID COLUMN_NAME     HID<br />
---------- --------------- ---<br />
         1 A               NO<br />
         2 C               NO<br />
         3 B               NO

SQL&gt;</pre>
</div></blockquote>
<h2>强制类型Invisible Columns</h2>
<p>隐含列的强制/可选等属性仍然是有效的，如下例：（隐含列的not null属性仍然是生效的）</p>
<blockquote><div>
<pre class="prettyprint linenums">DROP TABLE tab1 PURGE;

CREATE TABLE tab1 (<br />
  id          NUMBER NOT NULL,<br />
  description VARCHAR2(50) NOT NULL,<br />
  created_date DATE INVISIBLE NOT NULL<br />
);

COLUMN column_name FORMAT A20

SELECT column_id,<br />
       column_name,<br />
       nullable,<br />
       hidden_column<br />
FROM   user_tab_cols<br />
WHERE  table_name = 'TAB1'<br />
ORDER BY column_id;

 COLUMN_ID COLUMN_NAME          N HID<br />
---------- -------------------- - ---<br />
         1 ID                   N NO<br />
         2 DESCRIPTION          N NO<br />
           CREATED_DATE         N YES

SQL&gt;

INSERT INTO tab1 VALUES (1, 'ONE');<br />
*<br />
ERROR at line 1:<br />
ORA-01400: cannot insert NULL into ("TEST"."TAB1"."CREATED_DATE")

SQL&gt;

ALTER TABLE tab1 MODIFY created_date NULL;<br />
INSERT INTO tab1 VALUES (1, 'ONE');

1 row created.

SQL&gt;</pre>
</div></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnvm338.html">TP字母函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/m963nd49.html">Linux系统下的ssh使用&lpar;依据个人经验总结&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy5j2d9.html">PHP list，explode的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv10j1q.html">Android 编译Settings、Mms等模块，并Push到手机中安装失败</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okg3n59.html">浏览器后退按钮导致jquery动态添加的select option值丢失的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y7z20q.html">Selector中的各种状态详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj4e3d9.html">JBoss 系列九十九：Rest WebService jBPM 6 集成演示样例</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j037k4q.html">关于本地&dollar;&period;get&lpar;url&comma;function&lpar;data&rpar;&rpar;&comma;异步获取数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0ydjeq.html">python 利用位移法将ip转为number以及将number转为ip</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvgwgzq.html">offsetParent 到底是哪一个？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k3om69.html">Cnblogs美化总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjpv5x8.html">Win 10中使用图片查看器</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gxdnvq.html">1040 mysql Too many connections</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjz13r9.html">&lbrack;Bayes&rsqb; KL Divergence &amp;amp&semi; Evidence Lower Bound</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2mpe19.html">linux时间修改-hwclock和date</a>
		</li>
						<li><a href="https://www.batexi.com/a/953g2368.html">Atitit http2 新特性</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pjk0r8.html">【CF888G】Xor-MST Trie树（模拟最小生成树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmvr1g9.html">MySQL慢日志简介及Anemometer工具介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpr0nl9.html">fdisk命令详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4plkw0q.html">【Jmeter测试】使用Java请求进行Dubbo接口的测试</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/1q2krx3q.html">jQuery给动态添加的元素绑定事件的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx20ze8.html">signalr遇到的问题汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q77xnkq.html">unsigned无符号、有符号类型的符号拓展</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8km0679.html">错误信息：内存位置访问无效。 &lpar;Exception from HRESULT&colon; 0x800703E6&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e0yexq.html">Java框架--jQueryEasyUI</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxlk0jq.html">lucene大索引文件分布式存储方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96mm238.html">avl树的操作证明</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwoog39.html">&lbrack;Scala&rsqb; 快学Scala A2L2</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96mmvy8.html">【piu~】制作一只变形小鸡~</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kmve69.html">Unity3D代码旋转</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
